;===============================================
;=
;= Mega ST software interlacer tsr - takes
;= advantage of the Blitter chip. XBRA friendly
;=
;= by ray//.tSCc.			   2002
;===============================================

		opt	p=68000,d-,o+
		comment	HEAD=%001	; Set fastload header bit

		output	.prg


cookie		=	'2VRZ'		; Name of XBRA cookie

		section	text
_start		lea.l	message(pc),a0	; Infoscreen
		bsr.s	writeln

		pea.l	setup(pc)	; Run install routine
		move.w	#$26,-(sp)	; SupExec()
		trap	#14
		addq.l	#6,sp

		clr.w	-(sp)		; Terminate and stay resident
pterm_patch	pea.l	_end-_start+$100
		move.w	#$31,-(sp)
		trap	#1		
	

;==================================
;=
;=  Gemdos Writeln()
;=
;= expects a0 to point to the
;= string to be printed
;==================================

writeln		pea.l	(a0)
		move.w	#9,-(sp)	; Writeln()
		trap	#1
		addq.l	#6,sp

		rts


;==================================
;=
;=  Install the tsr
;=
;= waits for a key and sets up the
;= double height screen. initialises
;= patched vbl, gem and xbios vectors
;==================================

setup	

; Wait for user command or time out
	
		moveq.l	#6-1,d6

.wait		pea.l	$0bffff		; KbShift()
		trap	#13
		addq.l	#4,sp
		
		btst.l	#1,d0		; Left shift key being pressed?
		bne.s	.init		; Yes, then install 'em
		
		move.w	#'.',-(sp)	; Otherwise keep waiting
		move.w	#2,-(sp)	; Cconout()
		trap	#1
		addq.l	#4,sp
		
		move.l	$4ba.w,d0	; 200Hz ticks
		addi.l	#66,d0		; + ~0.33 seconds

.delay		cmp.l	$4ba.w,d0
		bgt.s	.delay
	
		dbra	d6,.wait
		

; Exit on time out

		move.w	#$4e41,pterm_patch; Patch in a 'trap #1'
		
		lea.l	not_installed(pc),a0
		bra.s	writeln
		
		
; Install tsr...
		
.init		move.w	#2,-(sp)	; Phybase()
		trap	#14
		addq.l	#2,sp
		move.l	d0,_phybase
		
		move.l	#_vram,d0
		clr.b	d0		; Align by 256 bytes (ST shifter)
		move.l	d0,_logbase	; New logbase


		movea.l	$44e.w,a0	; Remap old screen content to the
		move.l	d0,a1		; new logpage
		
		move.w	#32000/4-1,d1
.remap		move.l	(a0)+,(a1)+
		dbra	d1,.remap
		
		move.w	#-1,-(sp)
		pea.l	-1.w
		move.l	d0,-(sp)	; New logbase
		move.w	#5,-(sp)	; SetScreen()
		trap	#14
		lea.l	12(sp),sp
	
		clr.w	-(sp)		; Turn off the Blitter
		move.w	#$40,-(sp)
		trap	#14
		addq.l	#4,sp
	
		dc.w	$a000		; LineA $0 [init]
		move.l	a0,_LineA
		move.w	#400,-4(a0)	; Patch V_REZ_VT (vertical rez)
		move.w	#50,-$2a(a0)	; and V_CEL_MY   (text rows)

		move.l	$70.w,_oldvbl	; Store old vectors and
		move.l	#_vbl,$70.w	; install the new routines

		move.l	$b8.w,_oldxbios
		move.l	#_xbios,$b8.w
		
		move.l	$88.w,_oldgem
		move.l	#_gem,$88.w

		lea.l	installed(pc),a0; Success, print install message
		bra.w	writeln



;==================================
;=
;=  Patched XBIOS trap
;=
;= surpresses any attempts to turn
;= on the blitter
;==================================

		dc.l	'XBRA',cookie
_oldxbios	ds.l	1

_xbios		lea.l	6(sp),a0	; Get pointer to ssp into a0
		btst.b	#5,(sp)		; User mode?
		bne.s	.super
		move.l	usp,a0		; Point to usp

.super		cmpi.w	#$40,(a0)+	; BlitMode() call?
		bne.s	.return		; No, then call old XBIOS handler
	
		clr.w	(a0)		; Otherwise turn off the Blitter
	
.return		move.l	_oldxbios(pc),-(sp)
		rts	



;==================================
;=
;=  Patched GEM trap
;=
;= catch a possible VDI OpenWorkstation()
;= call in order to validate and use
;= the new screen height
;==================================

		dc.l	'XBRA',cookie
_oldgem		ds.l	1

_gem		cmpi.w	#$73,d0		; VDI call?
		bne.s	.return		; No, then return
		
		move.l	d1,a0
		move.l	(a0),a1		; Pointer to control structure
		
		cmpi.w	#1,(a1)		; OpenWorkstation() call?
		bne.s	.return		; No, then return

		move.l	12(a0),_gemend+2; Pointer to int_out
		move.l	2(sp),_gemret+2	; Old return adress
		move.l	#_gemend,2(sp)	; New return adress

.return		move.l	_oldgem(pc),-(sp); Call system handler
		rts

	opt	o-
_gemend		lea.l	$0.l,a0		; Pointer to int_out
		move.w	#400-1,2(a0)	; Vertical rez-1
		
_LineA		=	*+2
		lea.l	$0.l,a0		; LineA pointer
		move.w	#400,-4(a0)	; Vertical rez
		move.w	#50-1,-$2a(a0)	; Number of textrows-1
		move.w	#400-1,-690(a0)	; int_out(1)

_gemret		jmp	$0.l		; Patch in return address
	opt	o+			; here


;==================================
;=
;=  New VBL handler
;=
;= does the interlacing by copying
;= every second line of the double
;= height logpage and alternating
;= between odd and even rows each
;= time
;==================================

		dc.l	'XBRA',cookie
_oldvbl		ds.l	1
_interlace	dc.l	160		; Current skip line
_syncswitch	ds.b	1
_toggled	ds.b	1

_vbl

; Check sync toggle key (F10)

		cmpi.b	#$44,$fffffc02.w; F10 held?
		seq.b	_syncswitch	; Mark switch flag
		bne.s	.dont_switch
	
		tst.b	_toggled	; Switch only once
		bne.s	.dont_switch
		
		eori.b	#%10,$ffff820a.w; Toggle 50/60Hz
		
.dont_switch	move.b	_syncswitch(pc),_toggled

		btst.b	#7,$ffff8a3c.w	; Blitter busy?
		bne.s	.dont_blit	; Skip blit if so


; Blit one half screen...

		movem.l	d0/a0/a1,-(sp)
							
		lea.l	$ffff8a20.w,a0	; Blitter
		move.l	#$0200a0,(a0)+	; Source x- & y-increment

		move.l	_interlace(pc),d0; Interlace between
		swap.w	d0		 ; odd and even rows
		move.l	d0,_interlace

		movea.l	_logbase(pc),a1	; Source address
		adda.w	d0,a1
		move.l	a1,(a0)+

		moveq.l	#-1,d0		; Set endmasks to $ffff
		move.l	d0,(a0)+
		move.w	d0,(a0)+

		move.l	#$020000,(a0)+	   ; Destination x- & y-increment
		move.l	_phybase(pc),(a0)+ ; Destination address

		move.l	#$5100c8,(a0)+	; Copy 81*200 words
		move.w	#$0203,(a0)+	; hop & operation = source
		clr.w	(a0)		; Clear hog & skew

		moveq.l	#7,d0		
.blit		bset.b	d0,(a0) 	; Start Blitter
		nop
		bne.s	.blit		; Go on, if blitter isn't done

		movem.l (sp)+,d0/a0/a1
.dont_blit	move.l	_oldvbl(pc),-(sp)
		rts


;------------------------------------------------------------------------------
		section	data	
message		dc.b	13,10,27,'pMega ST interlace tsr  ray//.tSCc. 2002'
		dc.b	13,10,27,'qHold left shift key to install',13,10,0

installed	dc.b	13,10,'installed.',0
not_installed	dc.b	13,10,'not installed.',0

;------------------------------------------------------------------------------
		section	bss
_phybase	ds.l	1	; guess what ;)
_logbase	ds.l	1

_vram		=	*+256
		ds.b	64256	; Space for double height screen

_end		end